package net.lemnik.eodsql.impl;

import java.lang.annotation.Annotation;
import java.lang.reflect.Method;
import java.lang.reflect.Type;
import java.text.ParseException;

import net.lemnik.eodsql.spi.MethodImplementation;

/**
 * A factory for query method implementation parameters from dynamic invocation arguments. 
 *
 * @author Bernd Rinn
 */
interface DynamicParameterFactory {
    Annotation createAnnotation(final Object[] args);
    
    Class createBaseReturnType(final Object[] args);
    
    boolean isSingleRow();
    
    MethodImplementation<? extends Annotation> createMethodImplementation(Method method, 
            Annotation annotation, Class[] queryParamTypes, Type returnType, Object[] args) 
                    throws ParseException;
    
    String getSql(Object[] args);
}